//---------------------------------------------------------------------------
//
//   Lathe
//
//          Copyright(C) 1999, O.Mizno
//
//    @IuWFNg̃C]̂쐬IuWFNgvOC̃TvB
//    @쐬DLL"Plugins\Object"tH_ɓKvB
//
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "MQPlugin.h"
#include "MQ3DLib.h"
#include "resource.h"

HINSTANCE hInstance;

BOOL Lathe(MQDocument doc);
BOOL CALLBACK LatheDialogProc(HWND, UINT, WPARAM, LPARAM);


//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	//_CAO{bNX̕\ɕKvȂ̂ŁACX^XۑĂ
	hInstance = (HINSTANCE)hModule;

	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0x56A31D20;
	*ID      = 0xE0A5671C;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "Lathe           Copyright(C) 1999, O.Mizno";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// IuWFNgό`pvOCł
	return MQPLUGIN_TYPE_OBJECT;
}

//---------------------------------------------------------------------------
//  MQEnumString
//    |bvAbvj[ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumString(int index)
{
	switch(index){
	case 0: return "Lathe";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQModifyObject
//    j[IꂽƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQModifyObject(int index, MQDocument doc)
{
	switch(index){
	case 0: return Lathe(doc);
	}
	return FALSE;
}

struct {
	int segment;
} lathe;

//]̂̍쐬
BOOL Lathe(MQDocument doc)
{
	int obj_index, face_count, vert_count;
	int face, vert_index[2], new_vert[4];
	int **verts;
	int i,j,s;

	// JgIuWFNg̎擾
	obj_index = doc->GetCurrentObjectIndex();
	if(obj_index < 0)
		return FALSE;
	MQObject obj = doc->GetObject(obj_index);
	if(obj == NULL)
		return FALSE;

	face_count = obj->GetFaceCount();
	vert_count = obj->GetVertexCount();

	//C݂邩ǂ̃`FbN
	for(face=0; face<face_count; face++) {
		if(obj->GetFacePointCount(face) == 2)
			break;
	}
	if(face == face_count)
	{
		MessageBox(MQ_GetWindowHandle(), 
			"No lines in current object.", "Lathe", MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	// _CAO{bNX\
	if(DialogBox(hInstance, MAKEINTRESOURCE(DLG_LATHE), 
		MQ_GetWindowHandle(), LatheDialogProc) != TRUE)
		return FALSE;

	// ǉ钸_̃CfbNXL^Ăobt@m
	verts = (int **)malloc(sizeof(int *) * vert_count);
	for(i=0; i<vert_count; i++)
		verts[i] = NULL;

	for(face=0; face<face_count; face++)
	{
		//Q_̖(C)ł邩ǂ
		if(obj->GetFacePointCount(face) != 2)
			continue;

		obj->GetFacePointArray(face, vert_index);

		// ]̂ɂč쐬钸_ǉ
		for(j=0; j<2; j++)
		{
			if(verts[vert_index[j]] == NULL)
			{
				int *cv = (int *)malloc(sizeof(int) * lathe.segment);
				verts[vert_index[j]] = cv;

				MQPoint p = obj->GetVertex(vert_index[j]);

				cv[0] = vert_index[j];
				for(s=1; s<lathe.segment; s++)
				{
					double angle = (double)s / (double)lathe.segment * 2 * PI;
					cv[s] = obj->AddVertex(MQPoint(
						+ p.x * (float)cos(angle) + p.z * (float)sin(angle),
						p.y,
						- p.x * (float)sin(angle) + p.z * (float)cos(angle)));
				}
	
			}
		}

		// ʂ𗼖ʂƂč쐬
		for(s=0; s<lathe.segment; s++)
		{
			new_vert[0] = verts[vert_index[0]][s];
			new_vert[1] = verts[vert_index[0]][(s+1)%lathe.segment];
			new_vert[2] = verts[vert_index[1]][(s+1)%lathe.segment];
			new_vert[3] = verts[vert_index[1]][s];
			obj->AddFace(4, new_vert);

			new_vert[3] = verts[vert_index[0]][s];
			new_vert[2] = verts[vert_index[0]][(s+1)%lathe.segment];
			new_vert[1] = verts[vert_index[1]][(s+1)%lathe.segment];
			new_vert[0] = verts[vert_index[1]][s];
			obj->AddFace(4, new_vert);
		}

		// IWĩC폜
		obj->DeleteFace(face);
	}

	// svɂȂobt@폜
	for(i=0; i<vert_count; i++) {
		if(verts[i] != NULL)
			free(verts[i]);
	}
	free(verts);
	
	return TRUE;
}


// _CAO{bNX̃R[obN֐
BOOL CALLBACK LatheDialogProc(
  HWND hwndDlg, // handle to dialog box
  UINT uMsg, // message
  WPARAM wParam, // first message parameter
  LPARAM lParam // second message parameter
)
{
	switch(uMsg){
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case IDOK:
			{
				char buf[64];

				if(GetDlgItemText(hwndDlg, EDIT_SEGMENT, buf, sizeof(buf)) == 0) break;
				lathe.segment = atoi(buf);
			}
			EndDialog(hwndDlg, TRUE);
			break;
		case IDCANCEL:
			PostMessage(hwndDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	case WM_INITDIALOG:
		SetDlgItemText(hwndDlg, EDIT_SEGMENT, "10");
		return TRUE;

	case WM_CLOSE:
		EndDialog(hwndDlg, FALSE);
		break;
	}

	return FALSE;
}

 
