//---------------------------------------------------------------------------
//
//   MQBasePlugin
//
//          Copyright(C) 2000-2008, O.Mizno
//
//    @MetasequoiapvOCC^[tF[XAPIxB
//    C++̃NXƂĈ߂̃bp[łB
//      evOC̎ނƂɕK{API͏z֐ƂĒ`
//    Ă邽߁Å֐͌pNXŎsKv܂B
//
//---------------------------------------------------------------------------

#ifndef _MQBASEPLUGIN_H_
#define _MQBASEPLUGIN_H_

#include "MQPlugin.h"
#include <string>

class MQSetting;


// ׂẴvOC̊NX
class MQBasePlugin
{
public:
	// RXgN^
	MQBasePlugin();

	// fXgN^
	virtual ~MQBasePlugin();

	// vOCIDԂB
	virtual void GetPlugInID(DWORD *Product, DWORD *ID) = 0;

	// vOCԂB
	virtual const char *GetPlugInName(void) = 0;

	// vOC̃^CvԂB
	virtual int GetPlugInType(void) = 0;

	// ݒt@CJ
	MQSetting *OpenSetting(void);

	// ݒt@C
	void CloseSetting(MQSetting *setting);

	// ̃vOCɃvOCƎ̃bZ[W𑗂
	int SendUserMessage(MQDocument doc, DWORD target_product, DWORD target_id, const char *description, void *param);
};


// C|[gvOCNX
class MQImportPlugin : public MQBasePlugin
{
public:
	// vOC̃^CvԂB
	virtual int GetPlugInType(void) { return MQPLUGIN_TYPE_IMPORT; }

	// ͂܂͏o͉\ȃt@C^CvԂB
	virtual const char *EnumFileType(int index) = 0;

	// ͂܂͏o͉\ȊgqԂB
	virtual const char *EnumFileExt(int index) = 0;

	// t@C̓ǂݍ
	virtual BOOL ImportFile(int index, const char *filename, MQDocument doc) = 0;

};

// GNX|[gvOCNX
class MQExportPlugin : public MQBasePlugin
{
public:
	// vOC̃^CvԂB
	virtual int GetPlugInType(void) { return MQPLUGIN_TYPE_EXPORT; }

	// ͂܂͏o͉\ȃt@C^CvԂB
	virtual const char *EnumFileType(int index) = 0;

	// ͂܂͏o͉\ȊgqԂB
	virtual const char *EnumFileExt(int index) = 0;

	// t@C̏o
	virtual BOOL ExportFile(int index, const char *filename, MQDocument doc) = 0;

};

// j[^vOC̊NX
class MQMenuBasePlugin : public MQBasePlugin
{
public:
	// |bvAbvj[ɕ\镶ԂB
	virtual const char *EnumString(int index) = 0;

	virtual BOOL Execute(int index, MQDocument doc) = 0;
};

// 쐬vOCNX
class MQCreatePlugin : public MQMenuBasePlugin
{
public:
	// vOC̃^CvԂB
	virtual int GetPlugInType(void) { return MQPLUGIN_TYPE_CREATE; }
};

// IvOCNX
class MQSelectPlugin : public MQMenuBasePlugin
{
public:
	// vOC̃^CvԂB
	virtual int GetPlugInType(void) { return MQPLUGIN_TYPE_SELECT; }
};

// IuWFNgvOCNX
class MQObjectPlugin : public MQMenuBasePlugin
{
public:
	// vOC̃^CvԂB
	virtual int GetPlugInType(void) { return MQPLUGIN_TYPE_OBJECT; }
};

// 풓^vOCNX
/*
	풓^vOC̃x[XƂȂNXłB
	풓^vOC̓j[[pl]ɍڂǉAԂ̕ω
	bZ[WƂĎ󂯎AvOCƎ̏s܂B
*/
class MQStationPlugin : public MQBasePlugin
{
public:
	// OnNewDocument()̃p[^
	struct NEW_DOCUMENT_PARAM {
		MQXmlElement elem;	// vOCɂĕۑꂽXMLvf
	};

	// OnSaveDocument()̃p[^
	struct SAVE_DOCUMENT_PARAM {
		MQXmlElement elem;	// vOCɊ蓖ĂꂽۑpXMLvf
		BOOL bSaveUniqueID;	// j[NIDۑ邩ǂ
	};

	// GetSceneOption()̃p[^
	struct SCENE_OPTION {
		BOOL ShowVertex;	// _\
		BOOL ShowLine;		// ӂ\
		BOOL ShowFace;		// ʂ\
		BOOL FrontOnly;		// Oʂ̂ݕ\
		BOOL ShowBkimg;		// G\
	};

	// W^Cv
	enum COORDINATE_TYPE {
		COORDINATE_SCREEN	= 0,	// XN[W
		COORDINATE_WORLD	= 1,	// [hW
		COORDINATE_LOCAL	= 2,	// [JW
	};

public:
	// RXgN^
	MQStationPlugin();

	// vOC̃^CvԂB
	virtual int GetPlugInType(void) { return MQPLUGIN_TYPE_STATION; }

	// |bvAbvj[܂̓{^ɕ\镶ԂB
	virtual const char *EnumString(void) = 0;

	// AvP[V̏
	virtual BOOL Initialize() = 0;
	// AvP[V̏I
	virtual void Exit() = 0;

	// \E\؂ւv
	virtual BOOL Activate(MQDocument doc, BOOL flag) = 0;
	// \E\Ԃ̕ԓ
	virtual BOOL IsActivated(MQDocument doc) = 0;
	// EChE̍ŏւ̕ԓ
	virtual void OnMinimize(MQDocument doc, BOOL flag);
	// vOCƎ̃bZ[W̎󂯎
	virtual int OnReceiveUserMessage(MQDocument doc, DWORD src_product, DWORD src_id, const char *description, void *message);
	// `掞̏
	virtual void OnDraw(MQDocument doc, MQScene scene, int width, int height);

	// hLg
	virtual void OnNewDocument(MQDocument doc, const char *filename, NEW_DOCUMENT_PARAM& param);
	// hLgI
	virtual void OnEndDocument(MQDocument doc);
	// hLgۑ
	virtual void OnSaveDocument(MQDocument doc, const char *filename, SAVE_DOCUMENT_PARAM& param);
	// AhDs
	virtual BOOL OnUndo(MQDocument doc, int undo_state);
	// hDs
	virtual BOOL OnRedo(MQDocument doc, int redo_state);
	// AhDԍXV
	virtual void OnUpdateUndo(MQDocument doc, int undo_state, int undo_size);
	// IuWFNg̕ҏW
	virtual void OnObjectModified(MQDocument doc);
	// IuWFNg̑IԂ̕ύX
	virtual void OnObjectSelected(MQDocument doc);
	// JgIuWFNg̕ύX
	virtual void OnUpdateObjectList(MQDocument doc);
	// }eÃp[^ύX
	virtual void OnMaterialModified(MQDocument doc);
	// Jg}eA̕ύX
	virtual void OnUpdateMaterialList(MQDocument doc);
	// V[̕ύX
	virtual void OnUpdateScene(MQDocument doc, MQScene scene);


	// R[obN̊Jn
	void BeginCallback(void *option);

	// EChE
	void WindowClose();


private:
	struct StationCallbackInnerOption {
		MQStationPlugin *this_ptr;
		void *option;
	};

	// vOC̏ɑ΂R[obN
	static BOOL __stdcall StationCallback(MQDocument doc, void *option);

protected:
	// R[obNɑ΂
	virtual bool ExecuteCallback(MQDocument doc, void *option) = 0;

	// CreateDrawObject()visibilityɓniwj
	enum DRAW_OBJECT_VIISIBILITY {
		DRAW_OBJECT_POINT = 1,		// _\
		DRAW_OBJECT_LINE = 2,		// C\
		DRAW_OBJECT_FACE = 4,		// ʂ\
		DRAW_FORCE_DWORD = 0xFFFFFFFF,
	};

	// OnDraw()ɕ`IuWFNgǉ
	MQObject CreateDrawingObject(MQDocument doc, DRAW_OBJECT_VIISIBILITY visibility, BOOL instant=TRUE);

	// OnDraw()ɕ`IuWFNgp}eAǉ
	MQMaterial CreateDrawingMaterial(MQDocument doc, int& index, BOOL instant=TRUE);

	// `IuWFNg폜
	void DeleteDrawingObject(MQDocument doc, MQObject obj);

	// `IuWFNgp}eA폜
	void DeleteDrawingMaterial(MQDocument doc, MQMaterial mat);

	// ݂̃AhD̏ԃJE^擾
	int GetCurrentUndoState(MQDocument doc);

	// V[̕\IvV擾
	void GetSceneOption(MQScene scene, SCENE_OPTION& option);
};


// R}h^vOCNX
/*
	R}hvOC̃x[XƂȂNXłB
	R}hvOC̓R}hplɃ{^ǉA}EXȂǂ
	ɉƎ̏sƂł܂B
*/
class MQCommandPlugin : public MQStationPlugin
{
public:
	// }EXCxg̃p[^
	struct MOUSE_BUTTON_STATE {
		POINT MousePos;	// }EXJ[\̈ʒu
		int Wheel;		// }EXzC[̉]ʁiWHEEL_DELTA̔{܂͖񐔁j
		BOOL LButton;	// {^Ă邩
		BOOL MButton;	// {^Ă邩
		BOOL RButton;	// E{^Ă邩
		BOOL Shift;		// ShiftL[Ă邩
		BOOL Ctrl;		// CtrlL[Ă邩
		BOOL Alt;		// AltL[Ă邩
	};

	// EDIT_OPTION::SnapGrid, GetSnappedPos()ւ̎wij
	enum SNAP_GRID_TYPE {
		SNAP_GRID_X = 1,	// Xɋz
		SNAP_GRID_Y = 2,	// Yɋz
		SNAP_GRID_Z = 4,	// Zɋz
	};

	// GetEditOption()̃p[^
	struct EDIT_OPTION {
		BOOL EditVertex;	// _ҏW
		BOOL EditLine;		// CҏW
		BOOL EditFace;		// ʂҏW
		BOOL SelectRect;	// `I
		BOOL SelectRope;	// I
		BOOL SnapX;			// XɉҏW
		BOOL SnapY;			// YɉҏW
		BOOL SnapZ;			// ZɉҏW
		COORDINATE_TYPE CoordinateType;	// W̎
		SNAP_GRID_TYPE SnapGrid;		// Obhւ̋z
		BOOL Symmetry;		// ΏەҏW
		float SymmetryDistance;	// ΏۂƂ݂Ȃ
		BOOL CurrentObjectOnly;	// JgIuWFNĝ݂ҏW
	};

	// GetResourceCursor()̈
	enum MQCURSOR_TYPE {
		MQCURSOR_SIZEALL	= -22,		// S
		MQCURSOR_HANDPOINT	= -21,		// w
		MQCURSOR_HELP		= -20,		// ^╄t
		MQCURSOR_NO			= -18,		// ֎~
		MQCURSOR_WAIT		= -11,		// v
		MQCURSOR_UPARROW	= -10,		// 
		MQCURSOR_SIZEWE		= -9,		// Ew
		MQCURSOR_SIZENWSE	= -8,		// ƉEw
		MQCURSOR_SIZENS		= -7,		// ㉺w
		MQCURSOR_SIZENESW	= -6,		// Eƍw
		MQCURSOR_CROSS		= -3,		// \
		MQCURSOR_NONE		= -1,		// \
		MQCURSOR_DEFAULT	= 0,		// W
		MQCURSOR_RECT		= 1,		// ͈
		MQCURSOR_ROPE		= 2,		// 
		MQCURSOR_MOVE		= 3,		// ړ
		MQCURSOR_SCALE		= 4, 		// g
		MQCURSOR_ROTATE		= 5,		// ]
	};

	// HitTestŎgp^
	enum HIT_TYPE {
		HIT_TYPE_NONE	= 0,//Ȃ
		HIT_TYPE_VERTEX	= 1,//_
		HIT_TYPE_LINE	= 2,//C
		HIT_TYPE_FACE	= 4,//
	};

	// HitTest()̃p[^
	struct HIT_TEST_PARAM {
		// input
		BOOL TestVertex;	// _̌ms
		BOOL TestLine;		// Cm
		BOOL TestFace;		// ʂm

		// output
		HIT_TYPE HitType;	// mꂽ^Cv
		MQPoint HitPos;		// mꂽʒu
		int ObjectIndex;	// mꂽIuWFNg
		int VertexIndex;	// _̃CfbNXi_mꂽƂ̂݁j
		int LineIndex;		// C̃CfbNXiCmꂽƂ̂݁j
		int FaceIndex;		// ʂ̃CfbNXiC܂͖ʂmꂽƂ̂݁j

		HIT_TEST_PARAM(){
			TestVertex = TestLine = TestFace = true;
		}
	};

public:
	// RXgN^
	MQCommandPlugin();

	// vOC̃^CvԂB
	virtual int GetPlugInType(void) { return MQPLUGIN_TYPE_COMMAND; }
	// \E\Ԃ̕ԓ
	virtual BOOL IsActivated(MQDocument doc);
	// R[obNɑ΂
	virtual bool ExecuteCallback(MQDocument doc, void *option);

	// {^ꂽƂ
	virtual BOOL OnLeftButtonDown(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// {^Ȃ}EXړƂ
	virtual BOOL OnLeftButtonMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// {^ꂽƂ
	virtual BOOL OnLeftButtonUp(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// {^ꂽƂ
	virtual BOOL OnMiddleButtonDown(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// {^Ȃ}EXړƂ
	virtual BOOL OnMiddleButtonMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// {^ꂽƂ
	virtual BOOL OnMiddleButtonUp(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// E{^ꂽƂ
	virtual BOOL OnRightButtonDown(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// E{^Ȃ}EXړƂ
	virtual BOOL OnRightButtonMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// E{^ꂽƂ
	virtual BOOL OnRightButtonUp(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// }EXړƂ
	virtual BOOL OnMouseMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// }EX̃zC[]Ƃ
	virtual BOOL OnMouseWheel(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// L[ꂽƂ
	virtual BOOL OnKeyDown(MQDocument doc, MQScene scene, int key, MOUSE_BUTTON_STATE& state);
	// L[ꂽƂ
	virtual BOOL OnKeyUp(MQDocument doc, MQScene scene, int key, MOUSE_BUTTON_STATE& state);

protected:
	// AhDobt@XV
	void UpdateUndo();
	// V[̍ĕ`\񂷂
	void RedrawScene(MQScene scene);
	// ׂẴV[̍ĕ`\񂷂
	void RedrawAllScene();
	// ҏWIvV擾
	void GetEditOption(EDIT_OPTION& option);
	// Xibvʒu擾
	MQPoint GetSnappedPos(MQScene scene, const MQPoint& p, SNAP_GRID_TYPE type);
	// V[̎w肳ꂽʒuɂ̂m
	bool HitTest(MQScene scene, POINT p, HIT_TEST_PARAM& param);
	// W}EXJ[\擾
	HCURSOR GetResourceCursor(MQCURSOR_TYPE cursor_type);
	// }EXJ[\ݒ
	void SetMouseCursor(HCURSOR cursor);
	// Xe[^Xo[̕ݒ
	void SetStatusString(const char *str);
};


// vOC̃x[XNXԂ
extern MQBasePlugin *GetPluginClass();


#endif _MQBASEPLUGIN_H_
