#ifndef _STATION_SPY_PLUGIN_H_
#define _STATION_SPY_PLUGIN_H_

#include "MQBasePlugin.h"

class StationSpyPlugin : public MQStationPlugin
{
	friend class CMainDlg;

protected:
	CMainDlg *dlgMain;
	bool m_bActivate;
	bool m_bOnDraw;
	bool m_bOnUpdateScene;
	bool m_bOnUpdateUndo;

public:
	StationSpyPlugin();
	virtual ~StationSpyPlugin();

	// vOCIDԂB
	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	// vOCԂB
	virtual const char *GetPlugInName(void);
	// |bvAbvj[ɕ\镶ԂB
	virtual const char *EnumString(void);

	// AvP[V̏
	virtual BOOL Initialize();
	// AvP[V̏I
	virtual void Exit();

	// \E\؂ւv
	virtual BOOL Activate(MQDocument doc, BOOL flag);
	// \E\Ԃ̕ԓ
	virtual BOOL IsActivated(MQDocument doc);
	// EChE̍ŏւ̕ԓ
	virtual void OnMinimize(MQDocument doc, BOOL flag);
	// vOCƎ̃bZ[W̎󂯎
	virtual int OnReceiveUserMessage(MQDocument doc, DWORD src_product, DWORD src_id, const char *description, void *message);
	// `掞̏
	virtual void OnDraw(MQDocument doc, MQScene scene, int width, int height);

	// hLg
	virtual void OnNewDocument(MQDocument doc, const char *filename, NEW_DOCUMENT_PARAM& param);
	// hLgI
	virtual void OnEndDocument(MQDocument doc);
	// hLgۑ
	virtual void OnSaveDocument(MQDocument doc, const char *filename, SAVE_DOCUMENT_PARAM& param);
	// AhDs
	virtual BOOL OnUndo(MQDocument doc, int undo_state);
	// hDs
	virtual BOOL OnRedo(MQDocument doc, int redo_state);
	// AhDԍXV
	virtual void OnUpdateUndo(MQDocument doc, int undo_state, int undo_size);
	// IuWFNg̕ҏW
	virtual void OnObjectModified(MQDocument doc);
	// IuWFNg̑IԂ̕ύX
	virtual void OnObjectSelected(MQDocument doc);
	// JgIuWFNg̕ύX
	virtual void OnUpdateObjectList(MQDocument doc);
	// }eÃp[^ύX
	virtual void OnMaterialModified(MQDocument doc);
	// Jg}eA̕ύX
	virtual void OnUpdateMaterialList(MQDocument doc);
	// V[̕ύX
	virtual void OnUpdateScene(MQDocument doc, MQScene scene);


	typedef bool (StationSpyPlugin::*ExecuteCallbackProc)(MQDocument doc);

	void Execute(ExecuteCallbackProc proc);

	// ʂ̍폜
	bool DeleteFace(MQDocument doc);

protected:
	struct CallbackInfo {
		ExecuteCallbackProc proc;
	};

	// R[obNɑ΂
	virtual bool ExecuteCallback(MQDocument doc, void *option);
};


#endif _STATION_SPY_PLUGIN_H_
