//---------------------------------------------------------------------------
//
//   WTLTestPlugin
//
//          Copyright(C) 2006, O.Mizno
//
//    @풓vOC̃TvłB
//    @MQOt@CǂݏXMLt@C(.mqx)̑Aѕ`Iu
//    WFNg풓vOCǂ̂悤ɎgĂ܂B
//    @rhɂWTL(Windows Template Library)ʓrKvłB
//
//---------------------------------------------------------------------------
#include "stdafx.h"
#include "resource.h"
#include "maindlg.h"
#include "WTLTestPlugin.h"

static WTLTestPlugin plugin;


// RXgN^
WTLTestPlugin::WTLTestPlugin()
{
	dlgMain = NULL;
	m_bActivate = false;
	m_bShowLocal = false;
}

// RXgN^
WTLTestPlugin::~WTLTestPlugin()
{
	if (dlgMain != NULL){
		// Exit()Ŕj͂ꉞÔ߂ł
		dlgMain->DestroyWindow();
		delete dlgMain;
		dlgMain = NULL;
	}
}

//---------------------------------------------------------------------------
//  GetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
void WTLTestPlugin::GetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0x56A31D20;
	*ID      = 0x6A4102BF;
}

//---------------------------------------------------------------------------
//  GetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
const char *WTLTestPlugin::GetPlugInName(void)
{
	return "Test station with WTL       Copyright(C) 2006, O.Mizno";
}

//---------------------------------------------------------------------------
//  EnumString
//    |bvAbvj[ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
const char *WTLTestPlugin::EnumString(void)
{
	return "WTL station";
}


//---------------------------------------------------------------------------
//  Initialize
//    AvP[V̏
//---------------------------------------------------------------------------
BOOL WTLTestPlugin::Initialize()
{
	if (dlgMain == NULL){
		// AvP[VɃCEChẼnh蓖
		dlgMain = new CMainDlg(this);
		if(dlgMain->Create(MQ_GetWindowHandle()) == NULL)
		{
			delete dlgMain;
			dlgMain = NULL;
			ATLTRACE(_T("Main dialog creation failed!\n"));
			return 0;
		}

		// EChEɑOʂ
		dlgMain->SetWindowPos(HWND_TOPMOST, 0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
	}
	return TRUE;
}

//---------------------------------------------------------------------------
//  Exit
//    AvP[V̏I
//---------------------------------------------------------------------------
void WTLTestPlugin::Exit()
{
	if (dlgMain != NULL){
		dlgMain->DestroyWindow();
		delete dlgMain;
		dlgMain = NULL;
	}
}

//---------------------------------------------------------------------------
//  Activate
//    \E\؂ւv
//---------------------------------------------------------------------------
BOOL WTLTestPlugin::Activate(MQDocument doc, BOOL flag)
{
	if (dlgMain == NULL)
		return FALSE;

	m_bActivate = flag ? true : false;
	dlgMain->ShowWindow(m_bActivate ? SW_SHOW : SW_HIDE);
	if (m_bActivate){
		//dlgMain->UpdateList(doc);
	}
	return m_bActivate;
}

//---------------------------------------------------------------------------
//  IsActivated
//    \E\Ԃ̕ԓ
//---------------------------------------------------------------------------
BOOL WTLTestPlugin::IsActivated(MQDocument doc)
{
	if (dlgMain == NULL)
		return FALSE;

	return m_bActivate;
}

//---------------------------------------------------------------------------
//  OnNewDocument
//    hLg
//---------------------------------------------------------------------------
void WTLTestPlugin::OnNewDocument(MQDocument doc, const char *filename, NEW_DOCUMENT_PARAM& param)
{
	// XMLvfۑĂȂA܂͐VKhLg̏ꍇ͉Ȃ
	if (param.elem == NULL)
		return;

	// ۑꂽݒǂݍރTv
	MQXmlElement child;
	
	child = param.elem->FirstChildElement("ShowLocal");
	if (child != NULL){
		m_bShowLocal = atoi(child->GetText().c_str()) ? TRUE : FALSE;
		dlgMain->m_CheckShowLocal.SetCheck(m_bShowLocal ? 1 : 0);
	}
}

//---------------------------------------------------------------------------
//  OnSaveDocument
//    hLgۑ
//---------------------------------------------------------------------------
void WTLTestPlugin::OnSaveDocument(MQDocument doc, const char *filename, SAVE_DOCUMENT_PARAM& param)
{
	// ݒۑ邽߂XMLvf𖄂ߍރTv
	MQXmlElement child;
	
	child = param.elem->AddChildElement("ShowLocal");
	child->SetText(m_bShowLocal ? "1" : "0");
}

//---------------------------------------------------------------------------
//  OnDraw
//    `掞̏
//---------------------------------------------------------------------------
void WTLTestPlugin::OnDraw(MQDocument doc, MQScene scene, int width, int height)
{
	if (!m_bShowLocal)
		return;

	// _10sNZ̒Zo
	MQPoint sp = scene->Convert3DToScreen(scene->GetLookAtPosition());
	MQPoint p = scene->ConvertScreenTo3D(MQPoint(sp.x+10.0f,sp.y+10.0f,sp.z)) - scene->GetLookAtPosition();
	float len = p.abs();

	// IuWFNgƂ̃[JW̎`
	int numObj = doc->GetObjectCount();
	for (int i=0; i<numObj; i++)
	{
		MQObject obj = doc->GetObject(i);
		if (obj == NULL)
			continue;
		
		MQMatrix mtx;
		doc->GetGlobalMatrix(obj, mtx);

		// `IuWFNg𐶐
		MQObject axisX = this->CreateDrawingObject(doc, DRAW_OBJECT_LINE);
		MQObject axisY = this->CreateDrawingObject(doc, DRAW_OBJECT_LINE);
		MQObject axisZ = this->CreateDrawingObject(doc, DRAW_OBJECT_LINE);
		axisX->SetColor(MQColor(1,0,0));
		axisY->SetColor(MQColor(0,1,0));
		axisZ->SetColor(MQColor(0,0,1));
		axisX->SetColorValid(TRUE);
		axisY->SetColorValid(TRUE);
		axisZ->SetColorValid(TRUE);

		// e`IuWFNgɃCǉ
		int vert[2];
		vert[0] = axisX->AddVertex(MQPoint(0,0,0) * mtx);
		vert[1] = axisX->AddVertex(MQPoint(len,0,0) * mtx);
		axisX->AddFace(2, vert);
		vert[0] = axisY->AddVertex(MQPoint(0,0,0) * mtx);
		vert[1] = axisY->AddVertex(MQPoint(0,len,0) * mtx);
		axisY->AddFace(2, vert);
		vert[0] = axisZ->AddVertex(MQPoint(0,0,0) * mtx);
		vert[1] = axisZ->AddVertex(MQPoint(0,0,len) * mtx);
		axisZ->AddFace(2, vert);
	}
}

//---------------------------------------------------------------------------
//  OnObjectModified
//    IuWFNg̕ҏW
//---------------------------------------------------------------------------
void WTLTestPlugin::OnObjectModified(MQDocument doc)
{
	//m_pForm->UpdateList(doc);
}

//---------------------------------------------------------------------------
//  OnUpdateObjectList
//    JgIuWFNg̕ύX
//---------------------------------------------------------------------------
void WTLTestPlugin::OnUpdateObjectList(MQDocument doc)
{
	//m_pForm->UpdateList(doc);
}

//---------------------------------------------------------------------------
//  ExecuteCallback
//    R[obNɑ΂
//---------------------------------------------------------------------------
bool WTLTestPlugin::ExecuteCallback(MQDocument doc, void *option)
{
	CallbackInfo *info = (CallbackInfo*)option;
	return ((*this).*info->proc)(doc);
}

// R[obŇĂяo
void WTLTestPlugin::Execute(ExecuteCallbackProc proc)
{
	CallbackInfo info;
	info.proc = proc;
	BeginCallback(&info);
}


// ʂ
bool WTLTestPlugin::DeleteFace(MQDocument doc)
{
	// JgIuWFNg擾
	MQSelectFace sf;
	sf.object = doc->GetCurrentObjectIndex();
	MQObject obj = doc->GetObject(sf.object);
	if (obj == NULL)
		return false;

	// IĂʂ
	int numFace = obj->GetFaceCount();
	for (sf.face=0; sf.face<numFace; sf.face++){
		if (doc->IsSelectFace(sf)){
			obj->DeleteFace(sf.face);
		}
	}

	return true;
}


// vOC̃x[XNXԂ
MQBasePlugin *GetPluginClass()
{
	return &plugin;
}

